<template>
  <section class="wangeditor_class">
    <div ref="toolbar" class="toolbar"></div>
    <div>
      <el-upload
      class="upload-file"
      action="/apaas/static/image/upload"
      :on-success="uploadSuccess"
      :on-remove="handleRemove"
      :data="{directory: 'file' }"
      :limit="5"
      :file-list="fileArray">
      <el-button ref="upload_file" id="upload_file" size="small" type="primary" v-show="false">点击上传</el-button>
    </el-upload>
    </div>
    
  </section>
</template>
<script>
import E from "wangeditor";
const { BtnMenu } = E
//编辑器自定义按钮
class uploadMenu extends BtnMenu {
    constructor(editor) {
        const $elem = E.$(
            `<div class="w-e-menu" data-title="文档上传">
                <i class="el-icon-upload2"></i>
            </div>`
        )
        super($elem, editor)
    }
    clickHandler() {
      wangEuploadFile();
    }
    tryChangeActive() {
        this.active()
    }
}

export default {
  name: "editoritem",
  data() {
    return {
      // uploadPath,
      uploadMenu,
      editor: null,
      info_: null,
    };
  },
  model: {
    prop: "value",
    event: "change"
  },
  props: {
    value: {
      type: String,
      default: ""
    },
    isClear: {
      type: Boolean,
      default: false
    },
    isDisabled: {
      type: Boolean,
      default: false
    },
    fileArray: {
      type: Array,
      default: () => []
    }
  },
  watch: {
    isClear(val) {
      // 触发清除文本域内容
      if (val) {
        this.editor.txt.clear();
        this.info_ = null;
      }
    },
    value: function(value) {
      if (value !== this.editor.txt.html()) {
        this.editor.txt.html(this.value);
      }
    },
    isDisabled(value){
      console.log(value)
      this.editor.$textElem.attr("contenteditable", !value);
    },
    info_(val){
      console.log(val);
      this.$emit("change", val)
    },
    
    //value为编辑框输入的内容，这里我监听了一下值，当父组件调用得时候，如果给value赋值了，子组件将会显示父组件赋给的值
  },
  mounted() {
    this.seteditor();
    this.editor.txt.html(this.value);
    window.wangEuploadFile = this.wangEuploadFile
  },
  methods: {
    seteditor() {
      // http://192.168.2.125:8080/admin/storage/create
      this.editor = new E(this.$refs.toolbar);
      this.editor.config.uploadImgShowBase64 = false; // base 64 存储图片
      this.editor.config.uploadImgServer =
        "/apaas/static/image/upload"; // 配置服务器端地址
      this.editor.config.uploadImgHeaders = {}; // 自定义 header
      this.editor.config.uploadFileName = "file"; // 后端接受上传文件的参数名
        this.editor.config.uploadImgMaxSize = 2 * 1024 * 1024; // 将图片大小限制为 2M
      this.editor.config.uploadImgMaxLength = 6; // 限制一次最多上传 3 张图片
      this.editor.config.uploadImgTimeout = 3 * 60 * 1000; // 设置超时时间
      this.editor.config.uploadImgParams = { directory: "image" };

      this.editor.config.uploadImgHooks = {
        fail: (xhr, editor, result) => {
          // 插入图片失败回调
        },
        success: (xhr, editor, result) => {
          // 图片上传成功回调
        },
        timeout: (xhr, editor) => {
          // 网络超时的回调
        },
        error: (xhr, editor) => {
          // 图片上传错误的回调
        },
        customInsert: (insertImg, result, editor) => {
          // 图片上传成功，插入图片的回调
          //result为上传图片成功的时候返回的数据，这里我打印了一下发现后台返回的是data：[{url:"路径的形式"},...]
          // console.log(result.data[0].url)
          //insertImg()为插入图片的函数
          //循环插入图片
          // for (let i = 0; i < 1; i++) {
          console.log(result);
          let imgUrl = result.data;
          console.log(imgUrl);
          insertImg(imgUrl);
          // }
        }
      };
      this.editor.config.onblur = html => {
        this.info_ = html; // 绑定当前逐渐地值
        this.$emit("change", this.info_); // 将内容同步到父组件中
      };
      this.editor.config.onchange = html => {
        this.info_ = html; // 绑定当前逐渐地值
        this.$emit("change", this.info_); // 将内容同步到父组件中
      };

      this.editor.menus.extend('uploadMenusKey',uploadMenu)
      this.editor.config.menus.push('uploadMenusKey')

      // 创建富文本编辑器
      this.editor.create();
    },
    wangEuploadFile() {
      // this.$refs.upload_file.handleClick();
      document.getElementById('upload_file').click();
    },
    uploadSuccess(response, file, fileList) {
      if (response.success == 1) {
          this.fileArray.push({
            url: response.data,
            name: file.name,
          });
          this.$emit("getNewList", this.fileArray);
        }
    },
    handleRemove(file, fileList) {
      let url = file.url;
      let detection = true;
      if (url) detection = url.indexOf("blob") != -1;
      if (detection) {
        this.fileArray.forEach((item, i, arr) => {
          if (item.url === file.url) {
            this.fileArray.splice(i, 1);
          }
        });
      } else {
        this.fileArray.forEach((item, i, arr) => {
          if (item.url === file.url) {
            this.fileArray.splice(i, 1);
          }
        });
      }
      this.$emit("getNewList", this.fileArray);
    },
  }
};
</script>
<style>
.wangeditor_class{
  width: 100%;
}
.editor {
  width: 100%;
  margin: 0 auto;
  position: relative;
  z-index: 0;
}
.toolbar{
  height: 100%;
}
.toolbar .w-e-toolbar {
  border: none!important;
  border-bottom: 1px solid #e3e5ef!important;
  padding: 0;
}
.toolbar .w-e-toolbar .w-e-menu{
  width: 48px;
  height: 78px;
  font-size: 16px;
}
.toolbar .w-e-text-container {
  border: none!important;
  height: calc(100% - 80px)!important;
}
.upload-file {
  width: 50%;
}
</style>
